const reminderFox_nsIFilePicker = Components.interfaces.nsIFilePicker;
const g_reminderFoxBundle = document.getElementById("reminderFox-bundle");  
const filterCalendar    =g_reminderFoxBundle.getString("rf.options.filepicker.filter.calendar");
const filterSound    =g_reminderFoxBundle.getString("rf.options.filepicker.filter.sound");

const extensionCalendar = ".ics"; 
const extensionSound= ".wav"; 
var reminderFox_mPositionMax;


function reminderFox_loadOptions() {	
	var showStatus = REMINDER_FOX_SHOW_STATUS_TEXT_DEFAULT;			
	try {
		showStatus = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_STATUS_TEXT);
	} catch(e) {
	}			
	document.getElementById("reminderFox-statustext").setAttribute("checked", showStatus);

	var use24HourTime = REMINDER_FOX_USE_24_HOUR_TIME_DEFAULT;			
	try {
		use24HourTime = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USE_24_HOUR_TIME);
	} catch(e) {
	}			
	document.getElementById("reminderFox-use24Hour").setAttribute("checked", use24HourTime);
		
	var reminderFoxhideCompleted = false;			
	try {
		reminderFoxhideCompleted = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_HIDE_COMPLETED_ITEMS);
	} catch(e) {
	}			
	document.getElementById("reminderFox-hideCompleted").setAttribute("checked", reminderFoxhideCompleted);		
		

	var showRemindersInTooltip = REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP_DEFAULT;			
	try {
		showRemindersInTooltip = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP);
	} catch(e) {
	}			
	document.getElementById("reminderFox-showRemindersTooltip").setAttribute("checked", showRemindersInTooltip);

	var showTodosInTooltip = REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP_DEFAULT;			
	try {
		showTodosInTooltip = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP);
	} catch(e) {
	}			
	document.getElementById("reminderFox-showTodosTooltip").setAttribute("checked", showTodosInTooltip);
	
	var upcomingDays = UPCOMING_REMINDER_DAYS_DEFAULT;
	try {
		upcomingDays = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + UPCOMING_REMINDER_DAYS_PREF);
	} catch(e) {
	}
	document.getElementById("remindersUpcomingDays").setAttribute("value", upcomingDays);




	var defaultEditType = REMINDER_FOX_DEFAULT_EDIT_DEFAULT;			
	try {
		defaultEditType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_EDIT);
	} catch(e) {
	}	
	
	var defaultEdit = document.getElementById("reminderFox-default-doubleclick");	
	if ( defaultEditType == "todos" ) {
		defaultEdit.selectedIndex = 1; 
	}
	else {
		defaultEdit.selectedIndex = 0; 
	}
	
	
	var alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
	try {
		alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
	} catch(e) {
	}
						
	var showAlert = document.getElementById("reminderFox-showAlert");	
	
	// if the user has set it to no alerts, the option should be disabled
	if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_NONE ) {
		showAlert.setAttribute("checked", "false");	    
	}
	else {
		showAlert.setAttribute("checked", "true");	    
		
		if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_ALL ) {  
			document.getElementById("reminderFox-alertList").selectedIndex = 0;
		}
		else if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_TODAY ) {  
			document.getElementById("reminderFox-alertList").selectedIndex = 1;		
		}
		else if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING ) {  
				document.getElementById("reminderFox-alertList").selectedIndex = 2;
		}
	}
	
	var alertTimeout = REMINDER_FOX_ALERT_TIMEOUT_DEFAULT;
	try {
		alertTimeout = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF);
	} catch(e) {
	}
	document.getElementById("reminderFox-alertTimeout").setAttribute("value", alertTimeout);

	var upcomingLabel = REMINDER_FOX_UPCOMING_REMINDERS_LABEL_DEFAULT;
	try {
		upcomingLabel = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_UPCOMING_REMINDERS_LABEL);
	} catch(e) {
	}
	document.getElementById("upcomingLabelOptions").setAttribute("value", upcomingLabel);
	
	var todaysLabel = REMINDER_FOX_TODAYS_REMINDERS_LABEL_DEFAULT;
	try {
		todaysLabel = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TODAYS_REMINDERS_LABEL);
	} catch(e) {
	}
	document.getElementById("todaysLabelOptions").setAttribute("value", todaysLabel);	
	
	var dateListLabel = REMINDER_FOX_LIST_DATE_LABEL_DEFAULT;
	try {
		dateListLabel = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
	} catch(e) {
	}
	document.getElementById("dayAppearanceLabel").setAttribute("value", dateListLabel);		
	
	var playSound = true;
	try {
		playSound = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALARM_SOUND);
	}
	catch ( e) {
	}
	
	var playSoundAlert = true;
	try {
		playSoundAlert = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALERT_SOUND);
	}
	catch ( e) {
	}
	
	document.getElementById("reminderFox-alarmSound").setAttribute("checked", playSound );	
	document.getElementById("reminderFox-alertSound").setAttribute("checked", playSoundAlert );	
	var soundFilePath = "";
	// check if user has specified a specific file path for sound in their preferences
	try {
		soundFilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALARM_SOUND_PATH);
	}
	catch ( e) {
	}

	document.getElementById("reminderFox-alarm-sound-text-position").setAttribute("value", soundFilePath);
    var group = document.getElementById("reminderFox-alarmSound-group-position");    
	if ( soundFilePath == null || soundFilePath == "" ) {
	    group.selectedIndex = 0;
	}
	else {
	 	group.selectedIndex = 1;
	}
	
     var calStartDay;
	try {
		calStartDay = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_CALENDAR_START_DAY);
	} catch(e) {
		calStartDay = REMINDER_FOX_CALENDAR_START_DAY_DEFAULT;
	}	
	document.getElementById("reminderFox-startDay").selectedIndex = calStartDay;
	
		
	var savefilePath;
	// check if user has specified a specific file path in their preferences
	try {
		savefilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_STORE_FILE);
	}
	catch ( e) {
	}
	// if not, then use default location in profile
	if ( savefilePath == null || savefilePath == "" ) {
		document.getElementById("reminderFox-use-default-file-location").setAttribute("checked", true);		
	}
	else {
		document.getElementById("reminderFox-use-default-file-location").setAttribute("checked", false);
	}
	document.getElementById("reminderFox-file-location").setAttribute("value", reminderFox_getReminderStoreFile().path);
	reminderFox_fileLocationChanged();


	var networkSync = REMINDER_FOX_NETWORK_SYNCHRONIZE_DEFAULT;;			
	try {
		networkSync = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_NETWORK_SYNCHRONIZE);
	} catch(e) {
	}			
	document.getElementById("reminderFox-network-sync").setAttribute("checked", networkSync);

	
	
    var repeatUpcoming;
    var repeatGroup = document.getElementById("reminderFox-group-repeat-upcoming");    
    var repeatPositionText = document.getElementById("reminderFox-text-repeat-upcoming");
	try {
		repeatUpcoming = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_REPEAT_UPCOMING_OCCURRENCES);
	} catch(e) {
		repeatUpcoming = -1;
	}			
	if ( repeatUpcoming == -1 ) {
		repeatGroup.selectedIndex = 0;
	}
	else {
		repeatGroup.selectedIndex = 1;
		repeatPositionText.setAttribute("value", repeatUpcoming);
	}
	
	var repeatPrevious;
    repeatGroup = document.getElementById("reminderFox-group-repeat-previous");    
    repeatPositionText = document.getElementById("reminderFox-text-repeat-previous");
	try {
		repeatPrevious = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_REPEAT_PREVIOUS_OCCURRENCES);
	} catch(e) {
		repeatPrevious = -1;
	}			
	if ( repeatPrevious == -1 ) {
		repeatGroup.selectedIndex = 0;
	}
	else {
		repeatGroup.selectedIndex = 1;
		repeatPositionText.setAttribute("value", repeatPrevious);
	}
	
	
	
	
	///

	
	document.getElementById("reminderFox-alarmSound").setAttribute("checked", playSound );	
	document.getElementById("reminderFox-alertSound").setAttribute("checked", playSoundAlert );	
	var soundFilePath = "";
	// check if user has specified a specific file path for sound in their preferences
	try {
		soundFilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALARM_SOUND_PATH);
	}
	catch ( e) {
	}

	document.getElementById("reminderFox-alarm-sound-text-position").setAttribute("value", soundFilePath);
    var group = document.getElementById("reminderFox-alarmSound-group-position");    
	if ( soundFilePath == null || soundFilePath == "" ) {
	    group.selectedIndex = 0;
	}
	else {
	 	group.selectedIndex = 1;
	}
	
	
	var allDay = document.getElementById("reminderFox-all-day");	
	var allDayDefault = true;
	try {
		allDayDefault = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_ALL_DAY);
	} catch(e) {
	}	
	if (  allDayDefault ) { 
		allDay.setAttribute( "checked", true );	
	}
	else {
		allDay.setAttribute( "checked", false );	
	}
	
	
	
	var repeat = document.getElementById("reminderFox-repeat");	
	var repeatList = document.getElementById("reminderFox-repeatList");	
	var defaultRepeat;
	try {
		defaultRepeat = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_REPEAT);
	} catch(e) {
	}	
	if ( defaultRepeat < 0 ) {
		repeat.setAttribute( "checked", false );	
	}
	else {
		repeat.setAttribute("checked", true );
		repeatList.selectedIndex = defaultRepeat;
	}			
	
	var showAlert = document.getElementById("reminderFox-alert");	
	var alarmMinutes;
	try {
		alarmMinutes = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_ALARM_TIME);
	} catch(e) {
	}	
	if ( alarmMinutes < 0 ) {		
		showAlert.setAttribute( "checked", false );		
		// set alert time to first non-zero time 
		var alertTimesList = document.getElementById('reminderFox-alertTime');			
		alertTimesList.selectedIndex = 1;			
	}
	else {
		showAlert.setAttribute( "checked", true );	
		var alertTime = document.getElementById("reminderFox-alertTime");
		alertTime.label = alarmMinutes;
		var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
		var alarmUnitsIndex;
		try {
			alarmUnitsIndex = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_ALARM_UNITS);
		} catch(e) {
		}					
		timeUnitsList.selectedIndex = alarmUnitsIndex;
	}
	
	var remindUntilComplete = document.getElementById("remindUntilComplete");	
	var remindUntilCompleteDefault = false;
	try {
		remindUntilCompleteDefault = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_REMIND_UNTIL_COMPLETED);
	} catch(e) {
	}	
	remindUntilComplete.setAttribute( "checked", remindUntilCompleteDefault );

		
	
	// load settings of remote synchronization
	var proto = REMINDER_FOX_DEFAULT_PROTO;			
	try {
		proto = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_PROTO);
	} catch(e) {
	}	

	var protoMenu = document.getElementById("reminderFox-proto");	
	if ( proto == "ftp" ) {
		protoMenu.selectedIndex = 0; 
	} else if ( proto == "http" ) {
		protoMenu.selectedIndex = 1; 
	}
	else {
		protoMenu.selectedIndex = 2; 
	}

	var address = "";
	try {
		address = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ADDRESS);
	} catch(e) {
	}
	document.getElementById("reminderFox-text-address").setAttribute("value", address);

	var _username = "";
	try {
		_username = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USERNAME);
	} catch(e) {
	}
	document.getElementById("reminderFox-text-username").setAttribute("value", _username);


	var loginData = {
	    ljURL : proto + "://" + address,
	    username : _username,
	    password : ''
	};

	loginData = reminderFox_getPassword(loginData);
	if (loginData != null) {
		document.getElementById("reminderFox-text-password").setAttribute("value", loginData.password);
	}
	// end network
	
	// todo lists
	var  reminderFox_todoLists_listbox= document.getElementById("reminderFox_todoLists_listbox");
	var todoLists = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TODO_LISTS);
 	if ( todoLists != null && todoLists.length > 0) {
 		var todoListsArray = todoLists.split(",");
		for ( var i = 0; i < todoListsArray.length; i++ )  { 	
				var newItem = document.createElement("listitem");
				newItem.setAttribute( "label", todoListsArray[i]);
				newItem.setAttribute( "value",  todoListsArray[i]);			
				reminderFox_todoLists_listbox.appendChild(newItem);
		}
 	}
	
	
	
	reminderFox_populateBars();
	reminderFox_populatePositions();

	reminderFox_alertChanged();
	reminderFox_alertNotificationChanged();
	reminderFox_repeatChanged();
	reminderFox_groupPositionChanged();
	reminderFox_alarmSoundChanged();	
	reminderFox_alarmSoundGroupPositionChanged();	
	reminderFox_fileLocationChanged();
	reminderFox_ValidateSynchronization();
	reminderFox_repeatPreviousChanged();
	reminderFox_repeatUpcomingChanged();
	
}

function reminderFox_todoListsAdd() {
	var  reminderFox_newlist= document.getElementById("reminderFox_todosLists_text").value;
	var  reminderFox_todoLists_listbox= document.getElementById("reminderFox_todoLists_listbox");
	var newItem = document.createElement("listitem");

	newItem.setAttribute( "label", reminderFox_newlist);
	newItem.setAttribute( "value", reminderFox_newlist);
	reminderFox_todoLists_listbox.appendChild(newItem);
	document.getElementById("reminderFox_todosLists_text").value = "";
}

function reminderFox_todoListsRemove() {
	var  reminderFox_todoLists_listbox= document.getElementById("reminderFox_todoLists_listbox");
	var index = reminderFox_todoLists_listbox.selectedIndex;;
	var child = reminderFox_todoLists_listbox.childNodes[index];
	reminderFox_todoLists_listbox.removeChild(child);
}

function reminderFox_todoListsMoveUp() {
	var  reminderFox_todoLists_listbox= document.getElementById("reminderFox_todoLists_listbox");
	var index = reminderFox_todoLists_listbox.selectedIndex;;
	
	if ( index > 0 ) {
			var child = reminderFox_todoLists_listbox.childNodes[index-1];
			var moved = reminderFox_todoLists_listbox.removeChild(reminderFox_todoLists_listbox.childNodes[index]);			
			reminderFox_todoLists_listbox.insertBefore( moved, child );
			 reminderFox_todoLists_listbox.selectedIndex = index -1;
	}
}

function reminderFox_todoListsMoveDown() {
	var  reminderFox_todoLists_listbox= document.getElementById("reminderFox_todoLists_listbox");
	var index = reminderFox_todoLists_listbox.selectedIndex;;
	
	if ( index ==  reminderFox_todoLists_listbox.childNodes.length - 2 ) {
		var moved = reminderFox_todoLists_listbox.removeChild(reminderFox_todoLists_listbox.childNodes[index]);			
		reminderFox_todoLists_listbox.appendChild(moved);
		 reminderFox_todoLists_listbox.selectedIndex =  reminderFox_todoLists_listbox.childNodes.length - 1;;
		
	}
	else 	if ( index < reminderFox_todoLists_listbox.childNodes.length - 1 ) {
			var child = reminderFox_todoLists_listbox.childNodes[index];
			var moved = reminderFox_todoLists_listbox.removeChild(reminderFox_todoLists_listbox.childNodes[index+1]);			
			reminderFox_todoLists_listbox.insertBefore( moved, child );
					 reminderFox_todoLists_listbox.selectedIndex = index + 1;
	}
}



function reminderFox_fileLocationChanged() {
	var fileLocationChanged = "true";
	try {
		fileLocationChanged = document.getElementById("reminderFox-use-default-file-location").getAttribute("checked" );
	}
	catch(e) {
	}		
	
	if ( fileLocationChanged == false || fileLocationChanged == "false") {
			document.getElementById("reminderFox-file-location").removeAttribute("disabled" );			
			document.getElementById("reminderFox_file_location_browse").removeAttribute("disabled" );						
	}
	else {
			document.getElementById("reminderFox-file-location").setAttribute("disabled", "true");			
			document.getElementById("reminderFox_file_location_browse").setAttribute("disabled", "true");						
	}
}	
	

function reminderFox_updateOptions() {					
	var showStatusText = "true";
	try {
		showStatusText = document.getElementById("reminderFox-statustext").getAttribute("checked" );
	}
	catch(e) {
	}		

	try {
		if ( showStatusText != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_STATUS_TEXT, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_STATUS_TEXT, true);
		}
	} catch(e) {
	}	
	
	var use24HourText = "true";
	try {
		use24HourText = document.getElementById("reminderFox-use24Hour").getAttribute("checked" );
	}
	catch(e) {
	}		

	try {
		if ( use24HourText != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_USE_24_HOUR_TIME, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_USE_24_HOUR_TIME, true);
		}
	} catch(e) {
	}	
	
	var reminderFoxhideCompleted = "true";
	try {
		reminderFoxhideCompleted = document.getElementById("reminderFox-hideCompleted").getAttribute("checked" );
	}
	catch(e) {
	}		

	try {
		if ( reminderFoxhideCompleted != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_HIDE_COMPLETED_ITEMS, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_HIDE_COMPLETED_ITEMS, true);
		}
	} catch(e) {
	}	
		
		
	var showRemindersInTooltip =	"true";
	try {
		showRemindersInTooltip =	document.getElementById("reminderFox-showRemindersTooltip").getAttribute("checked" );
	}
	catch(e) {
	}		
	try {
		if ( showRemindersInTooltip != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP, true);
		}
	} catch(e) {
	}	
	
	
	var networkSync =	"true";;
	try {
		networkSync =	document.getElementById("reminderFox-network-sync").getAttribute("checked" );
	}
	catch(e) {
	}		
	try {
		if ( networkSync != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_NETWORK_SYNCHRONIZE, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_NETWORK_SYNCHRONIZE, true);
		}
	} catch(e) {
	}	
	
	var showTodosInTooltip =	"true";
	try {
		showTodosInTooltip =	document.getElementById("reminderFox-showTodosTooltip").getAttribute("checked" );
	}
	catch(e) {
	}	
	try {
		if ( showTodosInTooltip != "true" ) {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP, false);
		}
		else {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP, true);
		}
	} catch(e) {
	}	
		
	var upcomingDays =UPCOMING_REMINDER_DAYS_DEFAULT + "";
	try {
		upcomingDays = document.getElementById("remindersUpcomingDays").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setIntPref(UPCOMING_REMINDER_DAYS_PREF, upcomingDays);
	} catch(e) {
	}		
		
	var defaultEditIndex = 0;
	try {
		defaultEditIndex = document.getElementById("reminderFox-default-doubleclick").selectedIndex;
	}
	catch(e) {
	}		
	if ( defaultEditIndex == 1 ) {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_DEFAULT_EDIT, "todos");
	}
 	else {
 			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_DEFAULT_EDIT, "reminders");	
 	}		

	var showAlertVal =  true;
	try {
		var showAlert = document.getElementById("reminderFox-showAlert");	
		showAlertVal =  showAlert.getAttribute("checked" );
	}
	catch(e) {
	}	

	var alarmSound = document.getElementById("reminderFox-alarmSound");	
	var alarmSoundVal =  alarmSound.getAttribute("checked" );
	
	var alarmSoundAlert = document.getElementById("reminderFox-alertSound");	
	var alarmSoundAlertVal =  alarmSoundAlert.getAttribute("checked" );	
	
	var alarmEnabled = false;
	var alertEnabled = false;
	if ( alarmSoundVal == false || alarmSoundVal == "false") {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALARM_SOUND, false);
	}
	else {
			alarmEnabled = true;
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALARM_SOUND, true);
	}
	if ( alarmSoundAlertVal == false || alarmSoundAlertVal == "false") {
			reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALERT_SOUND, false);
	}	
	else {
		alertEnabled = true;
		reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_ALERT_SOUND, true);
	}
	if ( alarmEnabled ||  alertEnabled ) {
	    	var group = document.getElementById("reminderFox-alarmSound-group-position");    
		    if ( group.selectedIndex == 0 ) {	
		    	reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ALARM_SOUND_PATH, "");
		    }
		    else {
				var customAlaramFileLocation = document.getElementById("reminderFox-alarm-sound-text-position").value;
				reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ALARM_SOUND_PATH, customAlaramFileLocation);
			}
	}

	try {
		reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALARM_SOUND_PATH);
	} catch(e) {
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ALARM_SOUND_PATH, REMINDER_FOX_ALARM_SOUND_PATH__DEFAULT);
	}		
	

	var fileLocationChanged = "true";
	try {
		fileLocationChanged = document.getElementById("reminderFox-use-default-file-location").getAttribute("checked" );
	}
	catch(e) {
	}		
	if ( fileLocationChanged == false || fileLocationChanged == "false") {
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_STORE_FILE, 	 document.getElementById("reminderFox-file-location").value);						
	}
	else {
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_STORE_FILE, 	"");					
	}
	

	if ( showAlertVal == false  || showAlertVal == "false") {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_NONE);
	}
	else {
		var alertIndex =0;
		try {
			alertIndex = document.getElementById("reminderFox-alertList").selectedIndex;
		}
		catch(e) {
		}		
		try {
			if ( alertIndex == 0 ) {
					reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_ALL);
			}
			if ( alertIndex == 1 ) {
					reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_TODAY);
			}
			if ( alertIndex == 2 ) {
					reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING);
			}	
		}
		catch( e ) {
		}	
	
	}
	
	 var calStartDay; 
	try {
		calStartDay = document.getElementById("reminderFox-startDay").selectedIndex;
	} catch(e) {
		calStartDay = REMINDER_FOX_CALENDAR_START_DAY_DEFAULT;
	}	
	reminderFox_prefsBranch.setIntPref(REMINDER_FOX_CALENDAR_START_DAY, calStartDay);

	
	var oldAlertTimeout;
	try {
		oldAlertTimeout = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF);
	} catch(e) {
	}
	
	var alertTimeout = REMINDER_FOX_ALERT_TIMEOUT_DEFAULT + "";
	try {
		alertTimeout = document.getElementById("reminderFox-alertTimeout").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setIntPref(REMINDER_FOX_ALERT_TIMEOUT_PREF, alertTimeout);
	} catch(e) {
	}	

	if ( oldAlertTimeout != alertTimeout ){
		// need to clear the last alert in the case where alert timeout preference was changed 
		try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_LAST_ALERT, "");	
		} catch(e) {
		}		
	}
	
	var position =-1;
	var positionText;;
	try {
		position = document.getElementById("reminderFox-group-position");
		positionText = document.getElementById("reminderFox-text-position");
	}
	catch(e) {
	}	
	try {
	    if (parseInt(position.selectedItem.value) == -1)
	      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, -1);
	    else  {    
	        var textPosition = document.getElementById("reminderFox-text-position");
		    if (textPosition.value < 0 || textPosition.value > reminderFox_mPositionMax) {
		      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, -1);
		     }
		     else {
	    		reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, positionText.value);
	    	}      
	     }
     }
     catch(e) {
     }
	
	var toolbars = REMINDER_FOX_TOOLBAR_DEFAULT;
	try {
		 toolbars = document.getElementById("reminderFox-list-bars");
	}
   catch(e) {
	}	
	try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_TOOLBAR, toolbars.selectedItem.value);
	}
	catch(e) {
	}	
	

	try {
		var newLabel = document.getElementById("upcomingLabelOptions").value;
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_UPCOMING_REMINDERS_LABEL, newLabel);	
	} catch(e) {
	}	
	
	try {
		var newLabel = document.getElementById("todaysLabelOptions").value;
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_TODAYS_REMINDERS_LABEL, newLabel);	
	} catch(e) {
	}	
	
		try {
		var newLabel = document.getElementById("dayAppearanceLabel").value;
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_LIST_DATE_LABEL, newLabel);	
	} catch(e) {
	}	
	
	
	var repeatNumber =-1;
	try {
		repeatNumber = document.getElementById("reminderFox-group-repeat-upcoming");
	}
	catch(e) {
	}	
	try {
	    if (parseInt(repeatNumber.selectedItem.value) == -1)
	      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_REPEAT_UPCOMING_OCCURRENCES, -1);
	    else  {    
	        var repeatPosition = document.getElementById("reminderFox-text-repeat-upcoming");
		    if (repeatPosition.value < 0 ) {
		      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_REPEAT_UPCOMING_OCCURRENCES, -1);
		     }
		     else {
	    		reminderFox_prefsBranch.setIntPref(REMINDER_FOX_REPEAT_UPCOMING_OCCURRENCES, repeatPosition.value);
	    	}      
	     }
     }
     catch(e) {
     }	
	
	repeatNumber =-1;
	try {
		repeatNumber = document.getElementById("reminderFox-group-repeat-previous");
	}
	catch(e) {
	}	
	try {
	    if (parseInt(repeatNumber.selectedItem.value) == -1)
	      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_REPEAT_PREVIOUS_OCCURRENCES, -1);
	    else  {    
	        var repeatPosition = document.getElementById("reminderFox-text-repeat-previous");
		    if (repeatPosition.value < 0 ) {
		      reminderFox_prefsBranch.setIntPref(REMINDER_FOX_REPEAT_PREVIOUS_OCCURRENCES, -1);
		     }
		     else {
	    		reminderFox_prefsBranch.setIntPref(REMINDER_FOX_REPEAT_PREVIOUS_OCCURRENCES, repeatPosition.value);
	    	}      
	     }
     }
     catch(e) {
     }	
     
     
 	var allDay = "true";
	try {
		allDay =  document.getElementById("reminderFox-all-day");	
	}
	catch(e) {
	}		
	if ( allDay.getAttribute( "checked" ) == false ||  allDay.getAttribute( "checked" ) =="false" ) { 
		reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_DEFAULT_ALL_DAY, false);
	}
	else {
		reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_DEFAULT_ALL_DAY, true);
	}
	
	
	var repeat = document.getElementById("reminderFox-repeat");	
	if ( repeat.getAttribute( "checked" ) == false  ||  repeat.getAttribute( "checked" ) == "false" ) {
		 reminderFox_prefsBranch.setIntPref(REMINDER_FOX_DEFAULT_REPEAT, -1);			
	}
	else {
		var repeatList = document.getElementById("reminderFox-repeatList");	
		var selectedIndex = repeatList.selectedIndex;
		reminderFox_prefsBranch.setIntPref(REMINDER_FOX_DEFAULT_REPEAT, selectedIndex);			
	}
	
	var showAlert = document.getElementById("reminderFox-alert");	
	var alertVal =  showAlert.getAttribute("checked" );
	if ( alertVal == true || alertVal == "true") {
		var alertTime = document.getElementById("reminderFox-alertTime");
		var alertTimeVal = alertTime.label;		
		
		if ( reminderFox_isInteger( alertTimeVal ) ) {				
			 reminderFox_prefsBranch.setIntPref(REMINDER_FOX_DEFAULT_ALARM_TIME, alertTimeVal);			
			var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
			var timeSelected = timeUnitsList.selectedIndex;
			 reminderFox_prefsBranch.setIntPref(REMINDER_FOX_DEFAULT_ALARM_UNITS, timeSelected);			
		}		
	}		
	else {
		 reminderFox_prefsBranch.setIntPref(REMINDER_FOX_DEFAULT_ALARM_TIME, -1);			
	}

	var remindUntilComplete = document.getElementById("remindUntilComplete");	
	var remindUntilCompleteVal =  remindUntilComplete.getAttribute("checked" );
	if ( remindUntilCompleteVal == true || remindUntilCompleteVal == "true" ) { 	
		 reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_DEFAULT_REMIND_UNTIL_COMPLETED, true);					
	}
	else {
		 reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_DEFAULT_REMIND_UNTIL_COMPLETED, false);							
	}
	
	var  reminderFox_todoLists_listbox= document.getElementById("reminderFox_todoLists_listbox");
	var todoListsArray = new Array();
	for ( var i = 0; i < reminderFox_todoLists_listbox.childNodes.length; i++ ) {
		todoListsArray[i] = reminderFox_todoLists_listbox.childNodes[i].value;
	}
	reminderFox_setUnicodePref( REMINDER_FOX_TODO_LISTS, todoListsArray);


	// save of remote file options
	reminderFox_saveNetworkOptions();
	// end network
	
}

function reminderFox_saveNetworkOptions() {
	var protoIndex = 0;
	var proto = '';
	try {
		protoIndex = document.getElementById("reminderFox-proto").selectedIndex;
	}
	catch(e) {
	}		
	if ( protoIndex == 0 ) {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_PROTO, "ftp");
			proto = "ftp://";
	}else if ( protoIndex == 1 ) {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_PROTO, "http");
			proto = "http://";
	}
 	else {
 			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_PROTO, "https");	
			proto = "https://";
 	}	

	var address = "";
	try {
		address = document.getElementById("reminderFox-text-address").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ADDRESS, address);
	} catch(e) {
	}

	var _username = "";
	try {
		_username = document.getElementById("reminderFox-text-username").value;
	}
	catch(e) {
	}		
	try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_USERNAME, _username);
	} catch(e) {
	}

	var _password = "";
	try {
		_password = document.getElementById("reminderFox-text-password").value;
	}
	catch(e) {
	}		
//	if (_password != '') {  // we *do* want to allow the user to 'null' out their password and clear it
		var loginData = {
		    ljURL : proto + address,
		    username : _username,
		    password : _password,
		    savePassword : true
		};
		reminderFox_savePassword(loginData);
//	}	

}
function reminderFox_saveOptions() {
	if ( document.getElementById("reminderFox-apply").getAttribute("disabled" ) != true &&
		document.getElementById("reminderFox-apply").getAttribute("disabled" ) != "true" ) {
		reminderFox_updateOptions();
		reminderFox_updateWindows();
	}		
	document.getElementById("reminderFox-apply").setAttribute("disabled", true);
}

function reminderFox_saveOptionsAndClose() {

	reminderFox_updateOptions();
	window.close();
	if ( document.getElementById("reminderFox-apply").getAttribute("disabled" ) != true &&
		document.getElementById("reminderFox-apply").getAttribute("disabled" ) != "true" ) {
		reminderFox_updateWindows();
	}
}

function reminderFox_updateWindows() {
	try { 
		// update all of the browsers
		var windowEnumerator =  reminderFox_getWindowEnumerator();
		while (windowEnumerator.hasMoreElements()) {
			var currentWindow = windowEnumerator.getNext();		
			currentWindow.reminderFox_moveBox();

			currentWindow.reminderFox_updateRemindersInWindow();			
			currentWindow.reminderFox_clearRemindersAndTodos();
		}
	}
	catch( e ) {
	}
}


function reminderFox_updateButtons(aEvent)
{
  // don't enable the apply button for button presses
  if (aEvent) { 
    if ((aEvent.originalTarget.localName == "button") ||
        (aEvent.originalTarget.getAttribute("type") == "prof")) {
   	 return;
    }
  }

  document.getElementById("reminderFox-apply").removeAttribute("disabled");
}

function reminderFox_repeatChanged() {
	var repeat = document.getElementById("reminderFox-repeat");	
	var repeatVal =  repeat.getAttribute("checked" );
	if ( repeatVal == false || repeatVal == "false") {
			document.getElementById("reminderFox-repeatList").setAttribute("disabled", "true");	
	}
	else {
			document.getElementById("reminderFox-repeatList").removeAttribute("disabled" );
	}
}	

function reminderFox_alertNotificationChanged() { 
	var showAlert = document.getElementById("reminderFox-alert");	
	var alertVal =  showAlert.getAttribute("checked" );
	if ( alertVal == false || alertVal == "false") {
			document.getElementById("reminderFox-alertTime").setAttribute("disabled", "true");	
			document.getElementById("reminderFox-alertTimeUnits").setAttribute("disabled", "true");	
	}
	else {
			document.getElementById("reminderFox-alertTime").removeAttribute("disabled" );
			document.getElementById("reminderFox-alertTimeUnits").removeAttribute("disabled" );
	}

}

function reminderFox_alertChanged() {
	var showAlert = document.getElementById("reminderFox-showAlert");	
	var showAlertVal =  showAlert.getAttribute("checked" );
	if ( showAlertVal == false || showAlertVal == "false") {
			document.getElementById("reminderFox-alertTimeout").setAttribute("disabled", "true");
			document.getElementById("reminderFox-alertList").setAttribute("disabled", "true");
			document.getElementById("reminderFox-showAlert1").setAttribute("disabled", "true");
			document.getElementById("reminderFox-showAlert2").setAttribute("disabled", "true");			
			document.getElementById("reminderFoxDisplay").setAttribute("disabled", "true");			
	}
	else {
			document.getElementById("reminderFox-alertTimeout").removeAttribute("disabled" );
			document.getElementById("reminderFox-alertList").removeAttribute("disabled" );
			document.getElementById("reminderFox-showAlert1").removeAttribute("disabled" );
			document.getElementById("reminderFox-showAlert2").removeAttribute("disabled" );
			document.getElementById("reminderFoxDisplay").removeAttribute("disabled" );
	}
	
}	

function reminderFox_alarmSoundChanged() {
	var alarmSound = document.getElementById("reminderFox-alarmSound");	
	var alarmSoundVal =  alarmSound.getAttribute("checked" );
	var alertSound = document.getElementById("reminderFox-alertSound");	
	var alertSoundVal =  alertSound.getAttribute("checked" );	
	if ( (alarmSoundVal == false || alarmSoundVal == "false") && (alertSoundVal == false || alertSoundVal == "false")) {
			document.getElementById("reminderFox-alarmSound-group-position").setAttribute("disabled", "true");
			document.getElementById("sound1").setAttribute("disabled", "true");			
			document.getElementById("sound2").setAttribute("disabled", "true");						
			document.getElementById("reminderFox-alarm-sound-text-position").setAttribute("disabled", "true");
			document.getElementById("reminderFox_sound_browse").setAttribute("disabled", "true");
	}
	else {
			document.getElementById("reminderFox-alarmSound-group-position").removeAttribute("disabled" );
			document.getElementById("sound1").removeAttribute("disabled" );			
			document.getElementById("sound2").removeAttribute("disabled" );						
			document.getElementById("reminderFox-alarm-sound-text-position").removeAttribute("disabled" );
			document.getElementById("reminderFox_sound_browse").removeAttribute("disabled" );
			reminderFox_alarmSoundGroupPositionChanged();			
	}
}	


function reminderFox_groupPositionChanged() {
    var text = document.getElementById("reminderFox-text-position");
    var textValid = document.getElementById("reminderFox-text-position-valid");
    var group = document.getElementById("reminderFox-group-position");    
    
    if ( group.selectedIndex == 0 ) {
    	text.setAttribute("disabled", "true");
    	textValid.setAttribute("disabled", "true");    
    }
    else {
    	text.removeAttribute("disabled" );
    	textValid.removeAttribute("disabled" );
    }
}	

function reminderFox_repeatPreviousChanged() {
    var text = document.getElementById("reminderFox-text-repeat-previous");
    var group = document.getElementById("reminderFox-group-repeat-previous");    
    
    if ( group.selectedIndex == 0 ) {
    	text.setAttribute("disabled", "true");
    }
    else {
    	text.removeAttribute("disabled" );
    }
}	

function reminderFox_repeatUpcomingChanged() {
    var text = document.getElementById("reminderFox-text-repeat-upcoming");
    var group = document.getElementById("reminderFox-group-repeat-upcoming");    
    
    if ( group.selectedIndex == 0 ) {
    	text.setAttribute("disabled", "true");
    }
    else {
    	text.removeAttribute("disabled" );
    }
}	




function reminderFox_alarmSoundGroupPositionChanged() {
    var text = document.getElementById("reminderFox-alarm-sound-text-position");
    var group = document.getElementById("reminderFox-alarmSound-group-position");    
 	  var button = document.getElementById("reminderFox_sound_browse"); 
    
    if ( group.selectedIndex == 0 ) {
    	text.setAttribute("disabled", "true");
    	button.setAttribute("disabled", "true");
    }
    else {
		var alarmSound = document.getElementById("reminderFox-alarmSound");	
		var alarmSoundVal =  alarmSound.getAttribute("checked" );
		var alertSound = document.getElementById("reminderFox-alertSound");	
		var alertSoundVal =  alertSound.getAttribute("checked" );	
		if ( (alarmSoundVal == false || alarmSoundVal == "false") && (alertSoundVal == false || alertSoundVal == "false")) {    
		    text.setAttribute("disabled", "true");
    		button.setAttribute("disabled", "true");    
		}
		else {
	    	text.removeAttribute("disabled" );
	    	button.removeAttribute("disabled" );    	
	    }
    }
}	

function reminderFox_exportReminders() { 
	var i;
	
	// escape all commas
	var reminderFoxEvents = reminderFox_getReminderEvents();
	for ( i = 0; i < reminderFoxEvents.length; i++ ) {
		reminderFoxEvents[i].summary = reminderFoxEvents[i].summary.replace(/,/g,"\\,")
	}
	
	var reminderFoxTodosArrayArg = reminderFox_getReminderTodos();  //  ALL todos
	for ( var n in reminderFoxTodosArrayArg ) {
		var reminderFoxTodos = reminderFoxTodosArrayArg[n];
		for ( i = 0; i < reminderFoxTodos.length; i++ ) {
			reminderFoxTodos[i].summary = reminderFoxTodos[i].summary.replace(/,/g,"\\,")
		}
	}


	var outputStr = reminderFox_constructReminderOutput(reminderFoxEvents, reminderFoxTodosArrayArg, true);

    //get file
    var file = reminderFox_filePickerExport(0, window);
    if (!file)
      return;	
      
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to save file was denied.");
	}

	if ( file.exists() == false ) {
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
	}      
	
	reminderFox_writeStringToFile(outputStr, file, true);

	// show success message
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);
	promptService.alert(window,g_reminderFoxBundle.getString("rf.options.export.success.title"),	  g_reminderFoxBundle.getString("rf.options.export.success.description") );
}	

function reminderFox_mergeEvents( existingEvents, importedEvents ) {
	var i;
	for ( i = 0; i < importedEvents.length; i++ ) {
		var exists = reminderFox_eventExists( existingEvents, importedEvents[i] );
		if ( !exists ) {
			// add reminder in sorted order...
			var sortedIndex = reminderFox_getSortedIndexOfNewReminder( existingEvents, importedEvents[i], false );
			reminderFox_insertIntoArray( existingEvents,  importedEvents[i], sortedIndex );
		}
	}
}

function reminderFox_mergeTodos( existingTodosArray, importedTodosArray ) {	
	var i;
	for ( var n in importedTodosArray ) {
		var importedTodos = importedTodosArray[n];
		var existingTodos = existingTodosArray[n];
		
		if ( existingTodos == null ) {
			existingTodos = new Array();
			existingTodosArray[n] = existingTodos;
			for ( i = 0; i < importedTodos.length; i++ ) {
				var sortedIndex = reminderFox_getSortedIndexOfNewTodo( existingTodos, importedTodos[i] );
				reminderFox_insertIntoArray( existingTodos,  importedTodos[i], sortedIndex );
			}	
		}
		else {
			for ( i = 0; i < importedTodos.length; i++ ) {
				var exists = reminderFox_eventExists( existingTodos, importedTodos[i] );
				if ( !exists ) {
					// add todo in sorted order...
					var sortedIndex = reminderFox_getSortedIndexOfNewTodo( existingTodos, importedTodos[i] );
					reminderFox_insertIntoArray( existingTodos,  importedTodos[i], sortedIndex );
				}
			}
		}
	}		
}
function reminderFox_eventExists( existingEvents, importedEvent ) {
		for ( var i = 0; i < existingEvents.length; i++ ) {
			if ( existingEvents[i].id == importedEvent.id ) {
				return true;
			}
		}
		return false;
}
function reminderFox_importReminders() {
    var overWrite = false;
    var flags;
	var msg;
	var buttonPressed;
	var remindersArray;
	var i;
	var todo;
	var reminder;
    
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);

	flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
  	 	promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1 + 
   		promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2;
	msg =  g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.description.1") +"\n" +
		g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.description.2") + "\n" +
		g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.description.3");
	buttonPressed = promptService.confirmEx(window,g_reminderFoxBundle.getString("rf.options.import.overwriteoradd.title"),
	  msg,
	  flags, g_reminderFoxBundle.getString("rf.button.add"), g_reminderFoxBundle.getString("rf.button.cancel"), g_reminderFoxBundle.getString("rf.options.import.overwritebutton.title"), null, {});		  
	  

	// cancel pressed
	if (  buttonPressed == 1 ) {
		return ;
	}
	// overwrite pressed
	if ( buttonPressed == 2 ) {	
		// make sure they REAAAAALY want to overwrite
		flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
   			promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1;     
		msg = g_reminderFoxBundle.getString("rf.options.import.overwrite.description");
		buttonPressed = promptService.confirmEx(window,g_reminderFoxBundle.getString("rf.options.import.overwrite.title"),
		  msg,
		  flags,g_reminderFoxBundle.getString("rf.options.import.overwritebutton.title"), g_reminderFoxBundle.getString("rf.button.cancel"), null, null, {});		  
		  
		// cancel pressed
		if ( buttonPressed == 1 ) {	
			return;
		}	
		overWrite = true;
   }     
        
    //get file
    var file =reminderFox_filePickerImport(1, window);
    if (!file)
      return;
				
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to read file was denied.");
	}

	reminderEvents = new Array();
	reminderTodos = new Array();

	//if ( file.path.lastIndexOf( ".txt" ) == file.path.length - ".txt".length ) {
	//}
	//else {
		// ICS
		reminderFox_readInRemindersAndTodosICS(reminderEvents, reminderTodos, file, true);
		if ( overWrite ) {			
			reminderFoxEvents = reminderEvents;
			reminderFoxTodosArray = reminderTodos;
		}
		else { 
			// merge
			var existingEvents = reminderFox_getReminderEvents();
			var existingTodos = reminderFox_getReminderTodos();  //  ALL  todos
			reminderFox_mergeEvents(existingEvents, reminderEvents  );
			reminderFox_mergeTodos( existingTodos, reminderTodos );
		
			reminderFoxEvents = existingEvents;
			reminderFoxTodosArray = existingTodos;		
		}
	//}
	reminderFox_importRemindersUpdateAll(false, null );
	
	promptService.alert(window,g_reminderFoxBundle.getString("rf.options.export.success.title"),	  g_reminderFoxBundle.getString("rf.options.import.success.description")  );     
}	

function downloadReminders() {
	reminderFox_saveNetworkOptions();
	var options = { forceDownload: true };
	window.openDialog('chrome://reminderFox/content/network/download.xul', 'reminderFox-download', 'modal, centerscreen', options);
}

function uploadReminders() { 
	reminderFox_saveNetworkOptions();
	window.openDialog('chrome://reminderFox/content/network/upload.xul', 'reminderFox-upload', 'modal,centerscreen');
}





// split a string at newlines:   \n (Mac, *nix) or \r\n  (windows)
function reminderFox_splitOnAllNewlines(input) {
	// just use common newline to read in lines - check for strings that end in \r (to handle windows \r\n)
	var newline = "\n";
	var returnLine = "\r";
	
	var remindersArray = input.split(newline);	
	for ( var index = 0; index < remindersArray.length; index++ ) {
		var readIn = remindersArray[index];	
		if (readIn.length > 0 &&  readIn.lastIndexOf(returnLine) == readIn.length -1 ) {
			readIn = readIn.substring(0, readIn.length -1 );
			remindersArray[index] = readIn;
		}
	}	
	return remindersArray;
}

function reminderFox_pickSoundFile() {
    //get file
    var file =reminderFox_filePickerImportSound(window);
    if (!file)
      return;
   	var soundFilePath = file.path; 
   	document.getElementById("reminderFox-alarm-sound-text-position").setAttribute("value", soundFilePath);
}

function reminderFox_pickFileLocationFile() {
    //get file
    var file =reminderFox_fileLocationPicker( window);
    if (!file)
      return;
   	var fileLocation = file.path; 
   	document.getElementById("reminderFox-file-location").setAttribute("value", fileLocation);
}



function reminderFox_filePickerImport(aOpen, aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
    //picker.appendFilters( reminderFox_nsIFilePicker.filterText | reminderFox_nsIFilePicker.filterAll );
    picker.appendFilters( reminderFox_nsIFilePicker.filterAll );
    picker.appendFilter( filterCalendar, "*" + extensionCalendar );   
    picker.filterIndex=1;
   	picker.defaultExtension = "ics";
    switch (aOpen) {
      case 0:
        picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.export.filepicker.title"), reminderFox_nsIFilePicker.modeSave);
        break;
      case 1:
        picker.init(aWindow,g_reminderFoxBundle.getString("rf.options.import.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);
        break;
    };
    
    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	



function reminderFox_fileLocationPicker( aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
    picker.appendFilters( reminderFox_nsIFilePicker.filterAll );
    picker.appendFilter( filterCalendar, "*" + extensionCalendar );   
    picker.filterIndex=1
   	picker.defaultExtension = "ics";
    picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.filelocation.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);
    
    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	


function reminderFox_filePickerImportSound(aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
    picker.appendFilters(  reminderFox_nsIFilePicker.filterAll );
    picker.appendFilter( filterSound, "*" + extensionSound );   
    picker.filterIndex=1;
   	picker.defaultExtension = "wav";
    picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.sound.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);

    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	



function reminderFox_filePickerExport(aOpen, aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(reminderFox_nsIFilePicker);  
   
   	picker.defaultExtension = "ics";
    picker.appendFilter( filterCalendar, "*" + extensionCalendar );   
    switch (aOpen) {
      case 0:
        picker.init(aWindow, g_reminderFoxBundle.getString("rf.options.export.filepicker.title"), reminderFox_nsIFilePicker.modeSave);
        break;
      case 1:
        picker.init(aWindow,g_reminderFoxBundle.getString("rf.options.import.filepicker.title"), reminderFox_nsIFilePicker.modeOpen);
        break;
    };
    
    // get the file and its contents
    var res = picker.show();
    if (res == reminderFox_nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	


function reminderFox_concat(c1, c2)
{
  // Concats two collections into an array.
  var c3 = new Array(c1.length + c2.length);
  var x,y = 0;

  for (x = 0; x < c1.length; x++)
    c3[y++] = c1[x];

  for (x = 0; x < c2.length; x++)
    c3[y++] = c2[x];

  return c3;
}

function  reminderFox_populateBars()  {
    // Creates the menuitems for the toolbar selector.
    var win = reminderFox_getWindow();
    var toolbars = win.document.getElementsByTagName("toolbar");
    var statusbars = win.document.getElementsByTagName("statusbar");
    var menubars = win.document.getElementsByTagName("menubar");
    var popup = document.getElementById("reminderFox-popup-bars");
    var x, bar, item, val, list;
    
    // first remove the toolbars already there...
    while (popup.hasChildNodes())
      popup.removeChild(popup.firstChild);
          
    toolbars = reminderFox_concat(toolbars, statusbars);
    toolbars = reminderFox_concat(toolbars, menubars);
    for (x=0; x<toolbars.length; x++) {
      bar = toolbars[x];
      
      //do not include find toolbar
      if (bar.getAttribute("id") == "FindToolbar")
        continue;
             
      item = document.createElement("menuitem");
      item.setAttribute("id", bar.getAttribute("id"));
      item.value = bar.getAttribute("id");         
      if (bar.hasAttribute("toolbarname"))
        item.setAttribute("label", bar.getAttribute("toolbarname"));
      else
        item.setAttribute("label", bar.getAttribute("id"));                 
      popup.appendChild(item);
    }
    
    reminderFox_setElement("reminderFox-list-bars", "general.bar", "Char", "reminderFox-popup-bars");    
  }
function reminderFox_ValidateSynchronization() {
	  var text = document.getElementById("reminderFox-text-address");
	  if ( text.value == null || text.value == "" ) {
	  		document.getElementById("reminderFox_network_import_settings").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox_network_export_settings").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-network-sync").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-network-auto-desc").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-text-username").setAttribute("disabled", "true");
	  		document.getElementById("reminderFox-text-password").setAttribute("disabled", "true");
	  		
	  }
	  else {
	  		document.getElementById("reminderFox_network_import_settings").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox_network_export_settings").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-network-sync").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-network-auto-desc").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-text-username").removeAttribute( "disabled" );
	  		document.getElementById("reminderFox-text-password").removeAttribute( "disabled" );
	  }
	  
	 
}


  function reminderFox_populatePositions()   {
    var barid = document.getElementById("reminderFox-list-bars").selectedItem.getAttribute("id");
    var win = reminderFox_getWindow();
    var bar = win.document.getElementById(barid);

    if (!bar)
      reminderFox_mPositionMax = 0;
    else {
      var len = bar.childNodes.length;
    
      //don't include ourself in count
      if (win.document.getElementById("reminderFox-statusLabel").parentNode == bar)
        len--;
    
      reminderFox_mPositionMax = len;
        
    }

    var val;
	try {
		val = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR_POSITION);
	} catch(e) {
		val = -1;
	}		

    var val2 = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR);
    var text = document.getElementById("reminderFox-text-position");
    var radio = document.getElementsByAttribute("group", "position");
    var group = document.getElementById("reminderFox-group-position");
    var x, el;
    
    //set max value
    text.value = reminderFox_mPositionMax;
    
    //mark always last
    if (val == -1) {
      for (x=0; x < radio.length; x++) {
        if (parseInt(radio[x].value) == val) {
          group.selectedItem = radio[x];
          break;
        }
      }
    }
    
    //mark specific position
    else {
      for (x=0; x < radio.length; x++) {
        if (parseInt(radio[x].value) != -1) {
          group.selectedItem = radio[x];
          break;
        }
      }    
      if (barid != val2) {
        text.value = reminderFox_mPositionMax;
      } else {
        if (val < 0)
          text.value = reminderFox_mPositionMax;
        else if (val > reminderFox_mPositionMax)
          text.value = 0;
        else
          text.value = val; 
      }
    }
    
    // update the error label
    el = document.getElementById("reminderFox-text-position-valid");
    el.setAttribute("value", "(0-"+reminderFox_mPositionMax+")");
  }
  
  function  reminderFox_getWindow()  {
    //XXX may need to change this code if main window of a supported app is not "navigator:browser"
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
    var top = wm.getMostRecentWindow("navigator:browser");
	if ( !top ) {
	 	top = wm.getMostRecentWindow("mail:3pane");
	}
	if ( !top ) {
		top = wm.getMostRecentWindow("mail:messageWindow");
	}
    if (!top) {
    
    var guid;
          try {
        var app = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);    
        guid = app.ID;
      } catch(e) {
        var appBranch = prefService.getBranch(null);
        try {
          guid = appBranch.getCharPref("app.id");
        } catch(e) {
          guid = "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}";
        };    
      };
    
      switch (guid) {
        case "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}":
        case "{3db10fab-e461-4c80-8b97-957ad5f8ea47}":
        default:        
          top = ww.openWindow(null, "chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank");
          break;
        case "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}":
          top = ww.openWindow(null, "chrome://navigator/content/navigator.xul", "_blank", "chrome,all,dialog=no", "about:blank");
          break;
      };
    };
    return top;  
  }
  
  
    function reminderFox_setElement(aName, aPref, aType, aGroup)  {
    var x, el, els, val;
    
    el = document.getElementById(aName);
    
    val = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR);
    //val = eval("this.mBranch.get" + aType + "Pref('" + aPref + "')");
    switch (el.localName) {
      case "checkbox":
        el.checked = val;
        break;
      case "textbox":
        el.value = val;
        break;
      case "menulist":
        els = document.getElementById(aGroup).childNodes;        
        for (x=0; x < els.length; x++) {
          if (((aType == "Int") ? parseInt(els[x].value) : els[x].value) == val) {
            el.selectedItem = els[x];
            break;
          }
        }      
        break;            
      case "radiogroup":
        els = document.getElementsByAttribute("group", aGroup);        
        for (x=0; x < els.length; x++) {
          if (((aType == "Int") ? parseInt(els[x].value) : els[x].value) == val) {
            el.selectedItem = els[x];
            break;
          }
        }      
        break;
    }  
  }
  
function reminderFox_openCustomizeUpcomingLabelWindow() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("window:upcomingLabelOptions");
  
	if (topWindow) {
		topWindow.focus();
   	}
   	else {
   		var newOptions = { variableString:  document.getElementById("upcomingLabelOptions").value }
		window.openDialog("chrome://reminderfox/content/options/upcomingLabelOptions.xul", "upcomingLabelOptions", "chrome,modal", newOptions);
		document.getElementById("upcomingLabelOptions").value = newOptions.variableString;
		var upcomingLabelPref = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_UPCOMING_REMINDERS_LABEL);
		if (upcomingLabelPref != newOptions.variableString)
			document.getElementById("reminderFox-apply").removeAttribute("disabled");
	}
}

function reminderFox_openCustomizeTodayLabelWindow() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("window:upcomingLabelOptions");
  
	if (topWindow) {
		topWindow.focus();
   	}
   	else {
   		var newOptions = { variableString:  document.getElementById("todaysLabelOptions").value }
		window.openDialog("chrome://reminderfox/content/options/upcomingLabelOptions.xul", "todaysLabelOptions", "chrome,modal", newOptions);
		document.getElementById("todaysLabelOptions").value = newOptions.variableString;
		var upcomingLabelPref = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TODAYS_REMINDERS_LABEL);
		if (upcomingLabelPref != newOptions.variableString)
			document.getElementById("reminderFox-apply").removeAttribute("disabled");
	}
}



function reminderFox_loadCustomizeUpcomingLabelWindow() {
	var upcomingLabel = window.arguments[0].variableString;
	document.getElementById("upcomingLabelText").setAttribute("value", upcomingLabel);
}

function reminderFox_saveCustomizeUpcomingLabel() {
	var upcomingLabel = document.getElementById("upcomingLabelText").value;
	window.arguments[0].variableString = upcomingLabel;
	window.close();	
}
function reminderFox_openCustomizeReminderListDateWindow() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderListDateOptions");
  
	if (topWindow) {
		topWindow.focus();
   	}
   	else {
   		var newOptions = { variableString:  document.getElementById("dayAppearanceLabel").value }
		window.openDialog("chrome://reminderfox/content/options/listDateLabelOptions.xul", "listDateLabelOptions", "chrome,modal", newOptions);
		document.getElementById("dayAppearanceLabel").value = newOptions.variableString;
		var dayAppearanceLabelPref = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
		if (dayAppearanceLabelPref != newOptions.variableString)
			document.getElementById("reminderFox-apply").removeAttribute("disabled");
	}
}
