const reminderFoxBundle = document.getElementById("reminderFox-bundle");  
function reminderFox_saveOptions() {
		var newTodo = window.arguments[0].todo;
		
		var desc = document.getElementById("newTodoText");
		newTodo.summary = desc.value;

		var important = document.getElementById("importantTodo");	
		var importantVal =  important.getAttribute("checked" );
		if ( importantVal == true || importantVal == "true" ) { 
			newTodo.priority = REMINDER_PRIORITY_IMPORTANT;
		}
		else {
			newTodo.priority = REMINDER_PRIORITY_NORMAL;
		}
		
		var showInTooltip = document.getElementById("showInTooltip");
		var showInTooltipVal =  showInTooltip.getAttribute("checked" );
		if ( showInTooltipVal == true || showInTooltipVal == "true" ) { 
			newTodo.showInTooltip = true;
		}
		else {
			newTodo.showInTooltip = false;
		}	
		
		var notesText = document.getElementById("notesText");
		var notes =notesText.value;
		if ( notes != null ) {
			notes = reminderFox_trim( notes );
			if ( notes != "" ) {
				newTodo.notes = notes;
			}
			else { 
				newTodo.notes = null;
			}			
		} 		
		
		
		
		
		
		
		var todoDateCheckbox = document.getElementById("todoDateCheckbox");
		var dateEnabled =  todoDateCheckbox.getAttribute("checked" );
		if ( dateEnabled == true || dateEnabled == "true" ) { 
			var monthlist = document.getElementById('monthlist');
			var currentMonth = reminderFox_getMonthAsInteger(monthlist.label);		
			var daylist = document.getElementById('daylist');
			var currentDay =  daylist.label;
			var yearlist = document.getElementById('yearlist');
			var currentYear =  yearlist.label;
			
			if ( newTodo.date == null ) { 
				newTodo.date = new Date( currentYear, currentMonth, currentDay );
			}
			else { 
				if ( newTodo.date.getFullYear() !=currentYear ||
					newTodo.date.getMonth() != currentMonth ||
					newTodo.date.getDate() != currentDay ) {
					
					if (!reminderFox_isInteger( currentDay ) ) {
						currentDay = 	newTodo.date.getDate();
					}
					if (!reminderFox_isInteger( currentYear ) ) {
						currentYear = newTodo.date.getFullYear();
					}				
					newTodo.date = new Date( currentYear, currentMonth, currentDay );
				}		
			}	

			
			var allDay = document.getElementById("reminderFox-all-day");	
			if ( allDay.getAttribute( "checked" ) == false ||  allDay.getAttribute( "checked" ) =="false" ) { 
				try {
					var timeList = document.getElementById("reminderFox-timeList");	
					var time = timeList.label;
					var startindex = time.indexOf(reminderFoxBundle.getString("rf.add.time.delimiter") ); 
					// look for some other common delimiters...
					if ( startindex == -1 ) {
						startindex = time.indexOf(":" ); 
						if ( startindex == -1 ) {
							startindex = time.indexOf("." ); 
							if ( startindex == -1 ) {
								startindex = time.indexOf("h" ); 
							}
						}
					}
					if ( startindex != -1 ) {
						try {
							var hoursString = time.substring(0, startindex );
							if ( hoursString.length == 2 && hoursString.indexOf( "0" ) == 0 ) {
								hoursString = hoursString.substring(1);
							}
							var hours = parseInt(hoursString);
							var minutes =  time.substring(startindex+1, startindex + 3);
							// now trim remainder
							var remainder = time.substring( startindex + 3, time.length );
							if ( remainder != "" ) {
								remainder = reminderFox_trim( remainder );
								var AMorPM = remainder;
								if ( AMorPM.toUpperCase() == REMINDER_FOX_PM.toUpperCase() ) {
									if ( hours != 12 ) {
										hours = hours+12;
									}
								}
								else { 
									if ( hours == 12 ) {
										hours = 0;
									}
								}
							}
							if ( reminderFox_isInteger( hours +"" ) && reminderFox_isInteger( minutes ) ) {
								newTodo.date.setHours( hours, minutes );
							}
						}
						catch ( e ) {
						}
					}
					newTodo.allDayEvent = false;
				}
				catch( e ) {
				}
			}
			else {
				newTodo.allDayEvent = true;
			}
			
			var showAlert = document.getElementById("reminderFox-alert");	
			var alertVal =  showAlert.getAttribute("checked" );
			if ( alertVal == true || alertVal == "true") {
				var alertTime = document.getElementById("reminderFox-alertTime");
				var alertTimeVal = alertTime.label;		
				
				if ( reminderFox_isInteger( alertTimeVal ) ) {				
					var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
					var timeSelected = timeUnitsList.selectedIndex;
					if ( timeSelected == 0 ) {
						newTodo.alarm =  "-PT" + alertTimeVal + "M";				
					}
					else if ( timeSelected == 1 ) {
						newTodo.alarm =  "-PT" + alertTimeVal + "H";				
					}
					else if ( timeSelected == 2 ) {
						newTodo.alarm =  "-P" + alertTimeVal + "D";				
					}		
				}		
			}		
			else {
				newTodo.alarm = null;
			}			
			
		}	
		else {
			newTodo.date = null;
			newTodo.alarm = null;
			//newTodo.allDayEvent = true;
		}
		
		window.arguments[0].addTodo = true;

		window.close();

}


function reminderFox_alertChanged() {
	var showAlert = document.getElementById("reminderFox-alert");	
	var alertVal =  showAlert.getAttribute("checked" );
	if ( alertVal == false || alertVal == "false") {
			document.getElementById("reminderFox-alertTime").setAttribute("disabled", "true");	
			document.getElementById("reminderFox-alertInfo").setAttribute("disabled", "true");	
			document.getElementById("reminderFox-alertTimeUnits").setAttribute("disabled", "true");	
	}
	else {
			document.getElementById("reminderFox-alertTime").removeAttribute("disabled" );
			document.getElementById("reminderFox-alertInfo").removeAttribute("disabled" );
			document.getElementById("reminderFox-alertTimeUnits").removeAttribute("disabled" );
	}

}

function reminderFox_toggleNotes() {
	//openURL('http://www.csh.rit.edu/~tommut');
	var notesToggleButton = document.getElementById("notesToggle");
	var notesText = document.getElementById("notesText");
	if ( notesToggleButton.checked	 ) {
		notesText.setAttribute("hidden", "true");	
		notesToggleButton.setAttribute("tooltiptext", reminderFoxBundle.getString("rf.options.notes.tooltip.show"));	
	}
	else {
		notesText.setAttribute("hidden", "false");	
//		if ( notesText.value == "" ) {
//			notesText.focus();   
//		}
		notesToggleButton.setAttribute("tooltiptext", reminderFoxBundle.getString("rf.options.notes.tooltip.hide"));	
	}
	sizeToContent();	
}

function loadTodoOptions() {
		var newTodo = window.arguments[0].todo;
		var editing = window.arguments[0].editing;

		if ( editing ) {
			document.title = 	reminderFoxBundle.getString("rf.options.todo.edit.title");
		}
		else {
			document.title = 	reminderFoxBundle.getString("rf.options.todo.add.title");
		}		
		
		var use24HourTime;
		try {
			use24HourTime = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USE_24_HOUR_TIME);
		} catch(e) {
		}				
		if (  use24HourTime ) {
			var timeList = document.getElementById("reminderFox-timeList");	
			var items = timeList.firstChild.childNodes;
			for ( var i = 0; i < 24; i++ ) {
				var time = "";
				if ( i < 10 ) {
					time = "0";
				}
				items[i].label = time + i + ":" + "00";
			}
		}
		
		var desc = document.getElementById("newTodoText");
		desc.value = newTodo.summary;
		
		desc.focus();
		
		
		var notesToggleButton = document.getElementById("notesToggle");
		var notesText = document.getElementById("notesText");		
		if ( newTodo.notes != null ) {
			notesText.setAttribute("hidden", "false");	
			notesToggleButton.setAttribute( "checked", true );
			notesText.value = newTodo.notes;
			notesToggleButton.setAttribute("tooltiptext", reminderFoxBundle.getString("rf.options.notes.tooltip.hide"));	
			sizeToContent();			
		}
		else {
			notesText.setAttribute("hidden", "true");	
			notesToggleButton.removeAttribute( "checked" );	
			notesToggleButton.setAttribute("tooltiptext", reminderFoxBundle.getString("rf.options.notes.tooltip.show"));	
		}		
		
		if (newTodo.messageID != null){
			var displayMailButton = document.getElementById("displayMail");
			displayMailButton.setAttribute('style', 'visibility: visible');
			displayMailButton.setAttribute('disabled', 'false');
		}
		
		
		var important = document.getElementById("importantTodo");	
		if (  newTodo.priority == REMINDER_PRIORITY_IMPORTANT) { 
			important.setAttribute( "checked", true );
		}
		else {
			important.setAttribute( "checked", false );
		}
			
		var showInTooltip = document.getElementById("showInTooltip");	
		if ( newTodo.showInTooltip == true ) {
				showInTooltip.setAttribute( "checked", true );
		}
		else {
				showInTooltip.setAttribute( "checked", false );
		}
		var noCurrentDate = false;
		if ( newTodo.date == null ) {
			newTodo.date = new Date();
			noCurrentDate = true;
			var todoDateCheckbox = document.getElementById("todoDateCheckbox");
			todoDateCheckbox.setAttribute( "checked", false );			
		}
		else {
				var todoDateCheckbox = document.getElementById("todoDateCheckbox");
				todoDateCheckbox.setAttribute( "checked", true );
		}


		
		optionsSetNewReminderDate(newTodo.date, true);	
		
		optionsPopulateYearList(newTodo.date  );
		
		var allDay = document.getElementById("reminderFox-all-day");	
		var allDayDefault = true;
		if ( !editing ) {
			try {
				allDayDefault = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_ALL_DAY);
			} catch(e) {
			}	
		}
		if ( (noCurrentDate ||  newTodo.allDayEvent == true) && allDayDefault ) { 
			allDay.setAttribute( "checked", true );
			var use24HourTime;
			try {
				use24HourTime = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USE_24_HOUR_TIME);
			} catch(e) {
			}				
			if (  use24HourTime ) {
				var timeList = document.getElementById("reminderFox-timeList");	
				timeList.label =  timeList.firstChild.childNodes[0].label;
			}				
		}
		else {
			allDay.setAttribute( "checked", false );
			
			var hours = newTodo.date.getHours();
			var AMorPM = REMINDER_FOX_PM;
					
			var use24HourTime;
			try {
				use24HourTime = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USE_24_HOUR_TIME);
			} catch(e) {
			}				
			if (  use24HourTime ) {
				AMorPM = "";
				if ( hours < 10 ) {
					hours = "0" + hours;
				}
			}					
			
			if ( AMorPM != "" ) {			
				if ( hours < 12 ) {
					AMorPM = REMINDER_FOX_AM;
				}
				if ( hours == 0 ) {
					hours = 12;
				}
				if ( hours >= 13 ) {
					hours = hours -12;
				}
			}

			var minutes = newTodo.date.getMinutes();
			if ( minutes < 10 ) {
				minutes = "0" + minutes;
			}
			var timeList = document.getElementById("reminderFox-timeList");	
			
			var timeString = hours + reminderFoxBundle.getString("rf.add.time.delimiter") + minutes;
			if ( AMorPM != "" ) {
				timeString = timeString + " " + AMorPM;		
			}			
			timeList.label = timeString;
		}	
		if ( noCurrentDate ) { 
			newTodo.date = null;
		}	
		
		var showAlert = document.getElementById("reminderFox-alert");	
		
		if ( !editing ) {
			var alarmMinutes;
			try {
				alarmMinutes = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_ALARM_TIME);
			} catch(e) {
			}	
			if ( alarmMinutes < 0 ) {		
				showAlert.setAttribute( "checked", false );		
				// set alert time to first non-zero time 
				var alertTimesList = document.getElementById('reminderFox-alertTime');			
				alertTimesList.selectedIndex = 1;			
			}
			else {
				showAlert.setAttribute( "checked", true );	
				var alertTime = document.getElementById("reminderFox-alertTime");
				alertTime.label = alarmMinutes;
				var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
				var alarmUnitsIndex;
				try {
					alarmUnitsIndex = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_ALARM_UNITS);
				} catch(e) {
				}					
				timeUnitsList.selectedIndex = alarmUnitsIndex;
			}
		}
		else {
			if ( newTodo.alarm == null ) {
				showAlert.setAttribute( "checked", false );	
				
				// set alert time to first non-zero time 
				var alertTimesList = document.getElementById('reminderFox-alertTime');			
				alertTimesList.selectedIndex = 1;			
			}
			else {
				showAlert.setAttribute( "checked", true );	
				var alertTime = document.getElementById("reminderFox-alertTime");
				
				var alarmTime = newTodo.alarm;		 
				var result;
				var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
				var timeItems = timeUnitsList.firstChild.childNodes;
				
				var alarmIndex1 = alarmTime.indexOf( "-PT" );
				if ( alarmIndex1 != -1 ) {
					var alarmIndex2 = alarmTime.indexOf( "M", alarmIndex1 );
					if ( alarmIndex2 != -1 ) {
						alarmTime = alarmTime.substring( alarmIndex1 + "-PT".length, alarmIndex2 );		
						alertTime.label = alarmTime;
				    		timeUnitsList.selectedItem = timeItems[0];		
					}
					else {
						alarmIndex2 = alarmTime.indexOf( "H", alarmIndex1 );
						if ( alarmIndex2 != -1 ) {
							alarmTime = alarmTime.substring( alarmIndex1 + "-PT".length, alarmIndex2 );		
							alertTime.label =  alarmTime;
							timeUnitsList.selectedItem = timeItems[1];		
						}	
					}	
				}
				else {
					alarmIndex1 = alarmTime.indexOf( "-P" );
					if ( alarmIndex1 != -1 ) {
						var alarmIndex2 = alarmTime.indexOf( "D", alarmIndex1 );
						if ( alarmIndex2 != -1 ) {
							alarmTime = alarmTime.substring( alarmIndex1 + "-P".length, alarmIndex2 );		
							result = parseInt( alarmTime ) * 24 * 60;	
							alertTime.label =  alarmTime;
							timeUnitsList.selectedItem = timeItems[2];		
						}
					}
				}		
			}			
		}

		reminderFox_alertChanged();				
		
		
		reminderFox_allDayChanged();
		reminderFox_handleTodoDate();

		
		
}

function reminderFox_allDayChanged() {
	var allDay = document.getElementById("reminderFox-all-day");	
	var allDayVal =  allDay.getAttribute("checked" );
	if ( allDayVal == true || allDayVal == "true") {
			document.getElementById("reminderFox-timeList").setAttribute("disabled", "true");	
	}
	else {
			document.getElementById("reminderFox-timeList").removeAttribute("disabled" );
	}

}

function reminderFox_handleTodoDate() {
		var todoDateCheckbox = document.getElementById("todoDateCheckbox");
		var dateEnabled =  todoDateCheckbox.getAttribute("checked" );
		if ( dateEnabled == true || dateEnabled == "true" ) { 
			var dateItem = document.getElementById("monthlist");
			dateItem.removeAttribute("disabled");
			
			dateItem = document.getElementById("daylist");
			dateItem.removeAttribute("disabled")
			
			dateItem = document.getElementById("yearlist");
			dateItem.removeAttribute("disabled")
			
			dateItem = document.getElementById("timeDescLabel");
			dateItem.removeAttribute("disabled")				
			
			dateItem = document.getElementById("reminderFox-timeList");
			dateItem.removeAttribute("disabled")
			
			dateItem = document.getElementById("reminderFox-all-day");
			dateItem.removeAttribute("disabled")	
			
			dateItem = document.getElementById("reminderFox-alert");		
			dateItem.removeAttribute("disabled")	
			
			dateItem = document.getElementById("reminderFox-alertTime");
			dateItem.removeAttribute("disabled")	
			
			dateItem = document.getElementById('reminderFox-alertTimeUnits');						
			dateItem.removeAttribute("disabled")				
			
			dateItem = document.getElementById('reminderFox-alertInfo');				
			dateItem.removeAttribute("disabled")				
			
			reminderFox_allDayChanged();
			reminderFox_alertChanged();
				
		}
		else {
			var dateItem = document.getElementById("monthlist");
			dateItem.setAttribute("disabled", "true");	
			
			dateItem = document.getElementById("daylist");
			dateItem.setAttribute("disabled", "true");	
			
			dateItem = document.getElementById("yearlist");
			dateItem.setAttribute("disabled", "true");	
			
			dateItem = document.getElementById("timeDescLabel");
			dateItem.setAttribute("disabled", "true");						
			
			dateItem = document.getElementById("reminderFox-timeList");
			dateItem.setAttribute("disabled", "true");		
			
			dateItem = document.getElementById("reminderFox-all-day");
			dateItem.setAttribute("disabled", "true");						
			
			dateItem = document.getElementById("reminderFox-alert");		
			dateItem.setAttribute("disabled", "true");		
			
			dateItem = document.getElementById("reminderFox-alertTime");
			dateItem.setAttribute("disabled", "true");	
			
			dateItem = document.getElementById('reminderFox-alertTimeUnits');						
			dateItem.setAttribute("disabled", "true");		
			
			dateItem = document.getElementById('reminderFox-alertInfo');			
			dateItem.setAttribute("disabled", "true");					
		}
}


function optionsDateChanged(repopulateDays) {
	var monthlist = document.getElementById('monthlist');
	var month = reminderFox_getMonthAsInteger(monthlist.label);
	
	var daylist = document.getElementById('daylist');
	var day =daylist.label;
	
	// date  check --- if day is less than month; then set it to proper value
	var yearlist = document.getElementById('yearlist');
	var year = yearlist.label;
	day = reminderFox_getValidDateForMonth( year, month, day );
	
	var date = new Date( year, month, day );
	optionsSetNewReminderDate( date, repopulateDays );
	
	//updateRepeatingList(date);
}

function showMailInAlarm() {
	var displayMailButton = document.getElementById("displayMail");
	displayMailButton.setAttribute( "checked", false 	);	
	window.arguments[0].showMail = true;
	window.close();

}
